#splits the str files by state of the system; start by reading the str and status files
#
{print("Input flight name (YYYYMMDD[x] <ret> ^D <ret>):");flt<-scan(,what=character())}
infile.path<-paste("c:/QCLS/DATA/",flt,sep="")
nn<-scan(paste(infile.path,"\\infile",sep=""),what=character(),skip=1,n=13,flush=T)
start.end<-scan(paste(infile.path,"\\infile",sep=""),n=6,skip=9)
lim.day<-c(start.end[1]+start.end[2]/24+start.end[3]/(24*60),start.end[4]+start.end[5]/24+start.end[6]/(24*60))
fileid<-nn[1];path2cr10<-nn[3];path2str<-nn[10];path2strd<-nn[12]
print(nn)
print(c(start.end,lim.day))
#read the status file and the CO2 str file 
status<-
cc.str<-as.matrix(read.table(path2str,skip=1,header=F) )
cc.str[,1]=cc.str[,1]-3281990400.
day<-cc.str[,1]/86400+1 
lday<-day>lim.day[1] & day<lim.day[2]  # start of real data
if(sum(lday)==0)stop("No times in range for CO2")
  cc<-cbind(cc.str[lday,],day[lday]); dimnames(cc)<-list(NULL,c("GMTs","CO2.str","GMT_day"))
  if(PP==1)png(paste(infile.path,"\\analysis\\","CO2_raw",fileid,".png",sep=""))
  par(mar=c(4,4,4,1)+.15)
  plot(cc[,c(3,2)],type="l")
  title(line=2.5,main=fileid) 
  axis(side=3,at=cc[n7[l7],3],labels=as.character(hrp[l7]%%24))
if(PP==1)dev.off()
#
#======================o======================================================
dd.str<-as.matrix(read.table(path2strd,skip=1,header=F) )
dimnames(dd.str)<-list(NULL,c("GMTs","CH4","N2O","CO") )
dd.str[,1]=dd.str[,1]-3281990400.   #Jan 1 2008 igor time seconds
dday<-dd.str[,1]/86400+1 
if(sum(ldday)>0){
  ldday<-dday>lim.day[1] & dday<lim.day[2]  # start of real data
  dhr<-dday[ldday]*24; dhrp<-unique(trunc(dhr));dn7<- match(dhrp,round(dhr,3));dl7<-!is.na(dn7)
  dd<-cbind(dd.str[ldday,],dday[ldday]);dimnames(dd)<-list(NULL,c("GMTs","CH4","N2O","CO","Day") )
  if(PP==1)png(paste(infile.path,"\\analysis\\","DUAL_CO2_raw",fileid,".png",sep=""),height=1000,width=800)
  par(mfrow=c(2,2),mar=c(4,4,4,1)+.15)
  for(i in c("CH4","N2O","CO")){
  plot(dd[,c("GMTs",i)],type="l",axes=F);box();axis(2)
  axis(1,at=dd[dn7[dl7],1],labels=as.character(round(dd[dn7[dl7],1]%%86400,-1)))
  title(line=2.5,main=paste("Raw str",i,fileid)) 
  axis(side=3,at=dd[dn7[dl7],1],labels=as.character(dhrp[dl7]%%24))}
  plot(cc[,c(1,2)],type="l",axes=F);box();axis(2)
  axis(1,at=cc[n7[l7],1],labels=as.character(round(cc[n7[l7],1]%%86400,-1)))
  title(line=2.5,main=paste("Raw str CO2",fileid)) 
  axis(side=3,at=cc[n7[l7],1],labels=as.character(hrp[l7]%%24))
  if(PP==1)dev.off()
}
#============================================================================
#        plot the housekeeping data
for(i in 4:7){
N<-read.table(file=paste(nn[i],sep=""),as.is=T)
O<-as.matrix(read.table(skip=1,file=paste(path2cr10,"O",fileid,".",id,sep=""),header=F))
o.day=O[,2]+O[,3]/24+O[,4]/(60*24)+O[,5]/86400 ; tt<-(o.day - trunc(lim.day[1]))*86400 
# use tt to acct for day switch before startup of actual data 
print(paste("Time offset for",fileid,(trunc(o.day[1])-trunc(lim.day[1]))*86400,"secs"))
lo<-o.day>lim.day[1]&o.day<lim.day[2]
ihr<-O[,3];mm<-O[,4];ss<-O[,5]; ltick<-mm==0 & trunc(ss)==0
#
for(i in 1:16){
if((i-1)/4==trunc((i-1)/4)){
	if(i!=1 & PP==1)dev.off()
	lnewplot<-T
    } else {lnewplot<-F}
if(lnewplot){
if(PP==1)png(file=paste(infile.path,"/analysis/","O",fileid,id,"_",i,".png",sep=""),height=1000,width=800) 
par(mfrow=c(2,2))}
#remove single point outliers
#imin<-which(O[lo,i+5]==min(O[lo,i+5],na.rm=T)); if(length(imin)==1)O[lo,i+5][imin]==NA
#imax<-which(O[lo,i+5]==max(O[lo,i+5],na.rm=T)); if(length(imax)==1)O[lo,i+5][imax]==NA
plot(tt[lo],O[lo,i+5],axes=F,xlab="GMTs",ylab=N[i,3]);box();axis(2)
axis(side=3,at=tt[lo&ltick],labels=as.character(ihr[lo&ltick]))
axis(side=1,at=tt[lo&ltick],labels=as.character(round(tt[lo&ltick],-1)))
title(line=2.5,paste(N[i,2],fileid))
}
if(PP==1)dev.off()
}
#stc file extraction and plot
path2stc<-paste(substring(path2str,1,nchar(path2str)-1),"c",sep="")
path2stcd<-paste(substring(path2strd,1,nchar(path2strd)-1),"c",sep="")
dkeepers<-c("time","Range_F.1_L.1","Range_F.1_L.2","Range_F.2_L.1","Range_F.2_L.2","X1","pos1","X2","pos2")
ckeepers<-c("time","Range_F.1_L.1","Range_F.2_L.1","X1","pos1")
cc.stc<-as.matrix(read.table(path2stc,skip=1,header=T,sep=",",as.is=T)[,ckeepers] )
cc.stc[,1]=cc.stc[,1]-3281990400.
day<-cc.stc[,1]/86400+1 ; tt1<-(day-trunc(lim.day[1]))*86400
lday<-day>lim.day[1] & day<lim.day[2]  # start of real data
hr<-day[lday]*24; hrp<-unique(trunc(hr));n7<- match(hrp,round(hr,3));l7<-!is.na(n7)
cc<-cbind(cc.stc[lday,],day[lday]); dimnames(cc)<-list(NULL,c(dimnames(cc.stc)[[2]],"GMT_day"))
if(PP==1)png(paste(infile.path,"\\analysis\\","CO2_stc",fileid,".png",sep=""),height=1000,width=800)
par(mar=c(4,4,4,1)+.15,mfrow=c(2,2))
for(nn in ckeepers[2:5]){    plot(tt1[lday],cc[,nn],xlab="GMTs",ylab=nn,type="l")
title(line=2.5,main=paste(fileid,nn,"str")) 
axis(side=3,at=tt1[n7[l7]],labels=as.character(hrp[l7]%%24))}
if(PP==1)dev.off()
#======================o======================================================
dd.stc<-as.matrix(read.table(path2stcd,skip=1,header=T,sep=",",as.is=T)[,dkeepers] )
dd.stc[,1]=dd.stc[,1]-3281990400.  #Jan 1 2008 igor time seconds
dday<-dd.stc[,1]/86400+1 ; ttd1<-(dday-trunc(lim.day[1]))*86400
ldday<-dday>lim.day[1] & dday<lim.day[2]  # start of real data
dhr<-dday[ldday]*24; dhrp<-unique(trunc(dhr));dn7<- match(dhrp,round(dhr,3));dl7<-!is.na(dn7)
dd<-cbind(dd.stc[ldday,],dday[ldday]);dimnames(dd)<-list(NULL,c(dimnames(dd.stc)[[2]],"Day") )
if(PP==1)png(paste(infile.path,"\\analysis\\","DUAL_stc",fileid,"_1.png",sep=""),height=1000,width=800)
par(mar=c(4,4,4,1)+.15,mfrow=c(2,2))
for(nn in dkeepers[2:5]){    plot(ttd1[ldday],dd[,nn],type="l",xlab="GMTs",ylab=nn)
title(line=2.5,main=paste(nn,"str")) 
axis(side=3,at=ttd1[n7[l7]],labels=as.character(hrp[l7]%%24))}
mtext(line=-1,cex=.75,fileid)
if(PP==1)dev.off()
if(PP==1)png(paste(infile.path,"\\analysis\\","DUAL_stc",fileid,"_2.png",sep=""),height=1000,width=800)
par(mar=c(4,4,4,1)+.15,mfrow=c(2,2))
for(nn in dkeepers[6:9]){    plot(ttd1[ldday],dd[,nn],type="l",xlab="GMTs",ylab=nn)
title(line=2.5,main=paste(nn,"str")) 
axis(side=3,at=ttd1[n7[l7]],labels=as.character(hrp[l7]%%24))}
mtext(line=-1,cex=.75,fileid)
if(PP==1)dev.off()


