c23456789012345678901234567890123456789012345678901234567890123
        program split_qcl
	implicit real*8 (a-h,o-z)
      CHARACTER INPUTDATA*24,cr10line*512
      real*8 dip(58)
      REAL*8 UTIME
      INTEGER id,HOUR,MINT,nummit(6),day,nstatus(3),istatus(12,3)
	logical lfirst,lstatus(12,3)
        equivalence (istatus,lstatus)
      data nummit/4,19,16,16,16,12/
C nummit is (number of data points per line -1 <ID NOT CNTD>) >> rec. codes 1-7
C  1==100;2==201;3==202; 4==203 5==204  6==205
C
C Enter Input Data File : code H921104.raw (H921104.raw in separate subdir/mult flts
C any file name is acceptable, characters (2:7) will be used to tag the other files.
	open(55,file='infile',status='old')
c finds the name of the input file in 'infile', usually H080416.DAT
      READ(55,'(A24)') INPUTDATA
      print*,'Input data file is: ',inputdata
      OPEN(12,FILE=INPUTDATA,STATUS='OLD',recl=512,access='sequential',
     x action='read')
      OPEN(21,FILE='D'//INPUTDATA(2:7)//'.100',STATUS='unknown',recl=512,access='sequential')
      OPEN(22,FILE='D'//INPUTDATA(2:7)//'.201',STATUS='unknown',recl=512,access='sequential')
      OPEN(23,FILE='D'//INPUTDATA(2:7)//'.202',STATUS='unknown',recl=512,access='sequential')
      OPEN(24,FILE='D'//INPUTDATA(2:7)//'.203',STATUS='unknown',recl=512,access='sequential')
      OPEN(25,FILE='D'//INPUTDATA(2:7)//'.204',STATUS='unknown',recl=512,access='sequential')
      OPEN(26,FILE='D'//INPUTDATA(2:7)//'.205',STATUS='unknown',recl=512,access='sequential')
      OPEN(27,FILE='D'//INPUTDATA(2:7)//'.STS',STATUS='unknown',recl=512,access='sequential')
      OPEN(13,FILE='D'//INPUTDATA(2:7)//'.ERR',STATUS='unknown',recl=512,access='sequential')
      WRITE(13,*) ' ID = BAD CR10 RECORD:  WRONG ID : ',INPUTDATA
      WRITE(21,*) ' ID = 100 ,  FLIGHT DATE : ',INPUTDATA
      WRITE(22,*) ' ID = 201 ,  FLIGHT DATE : ',INPUTDATA
      WRITE(23,*) ' ID = 202 ,  FLIGHT DATE : ',INPUTDATA
      WRITE(24,*) ' ID = 203 ,  FLIGHT DATE : ',INPUTDATA
      WRITE(25,*) ' ID = 204 ,  FLIGHT DATE : ',INPUTDATA
      WRITE(26,*) ' ID = 205 ,  FLIGHT DATE : ',INPUTDATA
      WRITE(27,*) ' ID = 205 ,  FLIGHT DATE : ',INPUTDATA
      n1=0 
	nbadid=0
	nbaddata=0
C counter for # records
	utime0=-999.
	nneg=0
	idp=99
C intialize temp data to be passed between files:  read in 215, needed 215,201
	lfirst=.true.
10	n1=n1+1
	read(12,'(a)',end=90,err=599)cr10line
c      if(n1.lt.20)print*,n1,':',cr10line
	read(cr10line,*,err=1299)id
        if(id.eq.100) read(cr10line,*,err=1299)id,iyear,day,hhmm,secd
        if(id.eq.201)read(cr10line,*,err=1299)id,day,hhmm,secd
c      if(n1.lt.20)print*,id,day,hhmm,secd
c internal read 
	if(id.eq.201.or.id.eq.100)then
      HOUR=HHMM/100.
      MINT=HHMM-HOUR*100
	endif
	if(.not.lfirst)then
         if(HOUR*3600.+MINT*60.+SECD.lt.firstt)hour=hour+24
	end if 
      UTIME=HOUR*3600.+MINT*60.+SECD 
	if(lfirst)firstt=utime
	if(id.eq.201.or.id.eq.100)lfirst=.false.  
	if(utime.lt.utime0)then
792	format('neg time diff, rec. #',i5,2f10.3,2i6)
		write(92,792) n1,utime,utime0,id,idp
		nneg=nneg+1
	endif
	utime0=utime
C set first time to first '201'
check for bad ID (first record on the cr10line)
        if((id.ne.100).and.(id.lt.201.or.id.gt.205))go to 999
        if(id.eq.100) then
                n=21
        else
                n=21+id-200 
        end if
	nunit=n
c       if(n1.lt.20)print*,nummit(n-20),':',cr10line
        READ(cr10line,*,END=89,ERR=1299) ID,(dip(i),i=1,nummit(n-20))
c       if(n1.lt.20)print*,n1,' dip=',dip
c indices in dip() are 1 less than the rank in the table above 
        write(nunit,20) UTIME,HOUR,MINT,SECD,(dip(i),i=1,nummit(n-20))
        if(id.eq.205)then
                read(cr10line,*,END=89,ERR=1299) ID,x1,x2,(nstatus(i),i=1,3)
                call status_c(nstatus(1),lstatus(1,1),12)
                call status_c(nstatus(2),lstatus(1,2),12)
                call status_c(nstatus(3),lstatus(1,3),12)
                write(27,271)UTIME,HOUR,MINT,SECD,((istatus(i,j),i=1,12),j=1,3)
        endif
	idp=id
        goto 10
20    FORMAT(F8.1,2X,I2,2X,I2,2X,F5.2, (20F10.2,1x))
271    format(F8.1,2X,I2,2X,I2,2X,F5.2,1x, (36(i1,1x)))
30    FORMAT(8(F9.2,1X))
140    FORMAT(I3,2X,F8.1,2X,I2,2X,I2,2X,F5.2(/8(f9.2,1x)))
40    FORMAT(I3,2X,F8.1,2X,I2,2X,I2,2X,F5.2)
45    FORMAT(I3,2X,F8.1,2X,I2,2X,I2,2X,F5.2,2X,F2.0)
89      print *,'end of file, unit 12'
90      print *,'SPLIT_HI normal exit, # records read =',n1
	print*,'bad rec ID=',nbadid,'; bad data fields=', nbaddata
	if(nneg.eq.0)print*,'There were',nneg,' neg. time intervals'
	if(nneg.ne.0)print*,'WARNING, there were',nneg,' neg. time intervals'
      CLOSE(12)
      CLOSE(21)
      CLOSE(22)
      CLOSE(23)
C**     CLOSE(24)
      CLOSE(25)
      CLOSE(26)
        stop 0
999     write(13,'(a)')cr10line
	write(14,*)' record #',n1
	nbadid=nbadid+1
	go to 10
599     write(14,*)' unreadable record',n1
	nbaddata=nbaddata+1
        go to 10
1299    write(14,'(a)')cr10line
	write(14,*)' record #',n1
	nbaddata=nbaddata+1
        go to 10
        end
        subroutine status_c (istatus,kstatus,Nbits)
c       converts status word into integer status indicators
        integer istatus,twos(12)
        logical kstatus(12)
        data twos/2,4,8,16,32,64,128,256,512,1024,2048,4096/
        do i=1,Nbits
        kstatus(i)=mod(istatus,twos(i)).ge.(twos(i)/2)
        enddo
        return
        end 



