	program SIGSPL_H
c23456789012345678901234567890123456789012345678901234567890123
c ****  ER-2 data procsessing code ***** |
c ****     signal split by status  ***** |
c ****  ER-2 data procsessing code ***** |
c splits DYYMMDD.111 files into signal and cal files, median filtered
c by 10 secs.  Note time givenin .111 file is for the last reading in a 
c group.  Reading rate is 4 Hz.  Also creates a 1-sec median filter file
c with all licor data, a status word (binary), and a cell temp readout.
c coded by scw, 11-2-92
      CHARACTER*64 FIRSTLINE
      CHARACTER*24 FILENAME
      REAL F215DATA(55),secd
      REAL UTIME,median,time60(4800),co2mv(40),tv(4800),t2(4800)
     x ,rtime
      INTEGER HOUR,MINT,twon(5),huntf,nus(5)
      INTEGER ISOL(15),imask(4800),isl(4800,5)
	data twon/1,2,4,8,16/,nus/32,33,34,35,36/
      OPEN(12,FILE='infile',STATUS='old',recl=512,access='sequential')
      read(12,'(A24)')filename
c	print*,'sigspl_h filename=',filename
      OPEN(26,FILE='O'//filename(2:7)//'.215',STATUS='old',recl=512,access='sequential')
c contains status info
      READ(26,'(A64)') FIRSTLINE
	 n111 =1   
c  line counters
	 n215=1   
1     read(26,20,err=999,end=2) UTIME,HOUR,MINT,SECD
      read(26,40,err=999,end=2) (F215DATA(I),I=1,33)
      read(26,45,err=999,end=2) ISOL
c Isol assnmts: 2=ZER,3=PRI,4=LowStd,5=HiStd,6=SAMPLE
      read(26,40,err=999,end=2) (F215DATA(I),I=49,55)
      n215=n215+1
	time60(n215)=utime
	tv(n215)=F215DATA(1)  
c  "PV#2 T" ***Changed to T(Cell1),bcd,24April93***
	t2(n215)=F215DATA(2)   
c  "inst#2 T" ***Changed to T(Cell2),bcd,24April93***
	imask(n215)=0
      do 1001,j=1,5
      isl(n215,j)=isol(j+1)
	imask(n215)=isol(j+1)*twon(j)+imask(n215) 
c  binary status word
1001	continue	
c Isol assnmts: 2=ZER,3=PRI,4=LowStd,5=HiStd,6=SAMPLE
c binary status word: bit#1:zero;2,primary;3, lo-std;4,hi-std;5,SAMPLE
      goto1
20    FORMAT(F8.1,2X,I2,2X,I2,2X,F5.2)
30    FORMAT(8(F9.2,1X))
40    FORMAT(8(F9.2,1X))
45    FORMAT(17I3)
2	close(26)
	print*,'sigspl_h read',n215,' records from O'//filename(2:7)//'.215'
      write(99,28)((isl(i,j),j=1,5),imask(i),time60(i)
     x ,i=1,n215) 
28	format(5i4,2x,i4,2x,f9.2)
c	write(99,*)'number of 215 records=',n215
      OPEN(31,FILE='O'//filename(2:7)//'.ZER',STATUS='unknown',recl=512,access='sequential')
c zero 10s median ; primary ; lo-cal; hi-cal; sample; complete
      OPEN(32,FILE='O'//filename(2:7)//'.PRI',STATUS='unknown' ,recl=512,access='sequential')
      OPEN(33,FILE='O'//filename(2:7)//'.SLO',STATUS='unknown',recl=512,access='sequential')
      OPEN(34,FILE='O'//filename(2:7)//'.SHI',STATUS='unknown' ,recl=512,access='sequential')
      OPEN(35,FILE='O'//filename(2:7)//'.SAM',STATUS='unknown',recl=512,access='sequential')
      OPEN(37,FILE='O'//filename(2:7)//'.CON',STATUS='unknown' ,recl=512,access='sequential')
      print*,'sigspl_h opening ','D'//filename(2:7)//'.111'
      OPEN(22,FILE='D'//filename(2:7)//'.111',STATUS='old',recl=512,access='sequential')
c  licor output
      READ(22,'(A64)') FIRSTLINE
c read licor output file;  output median filter files, by status code; .CON
c file includes the status code.  Note that time in the .111 file is at the
c END (last reading) of each record.
c binary status word: bit#1:zero;2,primary;3, lo-std;4,hi-std;5,SAMPLE
      nhunt=1  
c  initial hunt guess
4     read(22,20,err=994,end=14)UTIME,HOUR,MINT,SECD
	read(22,30,err=994,end=14)co2mv
        n111=n111+1
        rtime=utime-5.   
c start time for block of 40 @ 4hz >>[corrected from fall pgm]<<
        nguess=max(nhunt,1)
        nhunt=huntf(time60,n215,utime,nguess) 
c find prev. status mask%
          if(nhunt.gt.0)then	
            do 1999 i=1,5
            if(isl(nhunt,i).ne.0)write(30+i,830)rtime,
     x median(40,co2mv),tv(nhunt),t2(nhunt) 
1999	continue
        end if 						 	        
c ----------------------------------------------------------------*******
c write 1-sec median, complete data          
          do 1998 i=1,10 
            write(37,837)utime-11.+float(i),
     x      median(4,co2mv((i-1)*4+1)),imask(max(nhunt,1)),nhunt       
1998	continue
c ---------------------------------------------------------------
        goto4
830	format(f9.2,1x,f10.3,1x,2f8.3)
837     format(f9.2,1x,f10.3,1x,i4,1x,i5)
14    continue
      stop 0
994   print*,'Error reading file .111',n111
        stop 994
999   print*,'Error reading file .215',n215
	stop 999
	end
c ++++++++++++++++ functions ++++++++++++++++++++++++++++++++++++
	function median(n,art)
c median of n points;  declare median==real.
code from p227 of Press, 1st ed.
	real arr(100),art(100),median,amedian,a
	integer n
	do 2001 k=1,n
	arr(k)=art(k)
2001    continue
 	do 12 j=2,n
	a=arr(j)
	do 11 i=j-1,1,-1
	if(arr(i).le.a) goto 10
 	arr(i+1)=arr(i)
11      continue
        i=0
10      arr(i+1)=a
12      continue
  	n2=n/2
        if (n2.eq.float(n)/2) amedian = (arr(n2)+arr(n2+1))/2.
        if (n2.ne.float(n)/2) amedian = arr(n2+1)
	median =amedian
2	return
	end
	function huntf(xx,n,x,jlo1)
	INTEGER jlo,n,inc,jhi,jm,huntf,jlo1
	REAL x,xx(n)
c from numerical recipes, 1992 ed.  Given monotonic array xx(1:n) and a value x
c returns value=Jlo such that x is between xx(jlo) and xx(jlo+1).  0,n=exceed
c range. jlo1 on input is the initial guess;  used for searches with rolling
c best guess.  Index put into polint() polynomial interpolator.
	LOGICAL ascnd
	jlo=jlo1
        ascnd=xx(n).gt.xx(1)
        if(jlo.le.0.or.jlo.gt.n)then 
c go to bisection straight off
         jlo=0
	 jhi=n+1
	 goto 3
	end if
	inc=1
	if(x.ge.xx(jlo).eqv.ascnd)then 
c hunt up, increment inc
1           jhi=jlo+inc
            if(jhi.gt.n)then
               jhi=n+1
            else if(x.ge.xx(jhi).eqv.ascnd)then 
c not done hunting
               jlo=jhi
               inc=inc+inc 
c double increment
               goto 1
            end if
         else                           
c hunt down
            jhi=jlo
2           jlo=jhi-inc
            if(jlo.lt.1)then
               jlo=0
            else if(x.lt.xx(jlo).eqv.ascnd)then
               jhi=jlo
               inc=inc+inc
               goto 2
            end if
        end if                          
c end of hunt for bracketting indexes
3 	if(jhi-jlo.eq.1)goto 30
        jm=(jhi+jlo)/2         
c begin biscection
        if(x.gt.xx(jm).eqv.ascnd)then
          jlo=jm
        else
          jhi=jm
        end if
        goto 3
30      huntf=jlo
        return
	END


