c23456789012345678901234567890123456789012345678901234567890123
        program split_qcl
	implicit real*8 (a-h,o-z)
      CHARACTER INPUTDATA*50,OP*50,cr10line*512,flt*11,firstline*10,Z*8
      real*8 dip(58), UTIME
      INTEGER id,HOUR,MINT,nummit(8),day,day1,nstatus(3),istatus(12,3),iflt
	logical lfirst,lstatus(12,3)
        equivalence (istatus,lstatus)
c--------------------------------------------------------------------
      data nummit/4,  4, 19, 16, 16, 16, 14, 5/
c ^ # entries in 100 200 201 202 203 204 205 400  = id ^
C nummit is (number of data points per line -1 <ID is NOT Counted>)
c--------------------------------------------------------------------
C  1==100;2==200;3==201; 4==202 5==203  6==204  7==205 8=400
c 'infile' must be in the folder where split_qcl is started; content is documented inside
C  it lists the names and paths for files used in the processing stream
	open(55,file='infile',status='old')
c
      READ(55,'(A10)') FIRSTLINE
      READ(55,'(A11)') FLT
      READ(55,'(A50)') INPUTDATA
      print*,'Input data file is: ',inputdata
      READ(55,'(A50)') OP
      close(55)
      print*,'Output Path = ',OP
c   early QCLS flights had only 12 entries in ID=205
      Z=FLT(1:8)
      read(Z,'(i8)')iflt
      if(iflt .le. 20080424)nummit(7)=12
      print*,'iflt=',iflt,' nummit(7)=',nummit(7)
c     
      print*,'input file for CR10 data=',INPUTDATA
      OPEN(12,FILE=INPUTDATA,STATUS='OLD',recl=512,access='sequential')
      print*,' Output file ex. ',OP(1:lentrim(OP))//'D'//FLT(1:lentrim(FLT))//'.ERR'
      OPEN(13,FILE=OP(1:lentrim(OP))//'D'//FLT(1:lentrim(FLT))//'.ERR',STATUS='unknown',recl=512,access='sequential')
      OPEN(20,FILE=OP(1:lentrim(OP))//'D'//FLT(1:lentrim(FLT))//'.100',STATUS='unknown',recl=512,access='sequential')
      OPEN(21,FILE=OP(1:lentrim(OP))//'D'//FLT(1:lentrim(FLT))//'.200',STATUS='unknown',recl=512,access='sequential')
      OPEN(22,FILE=OP(1:lentrim(OP))//'D'//FLT(1:lentrim(FLT))//'.201',STATUS='unknown',recl=512,access='sequential')
      OPEN(23,FILE=OP(1:lentrim(OP))//'D'//FLT(1:lentrim(FLT))//'.202',STATUS='unknown',recl=512,access='sequential')
      OPEN(24,FILE=OP(1:lentrim(OP))//'D'//FLT(1:lentrim(FLT))//'.203',STATUS='unknown',recl=512,access='sequential')
      OPEN(25,FILE=OP(1:lentrim(OP))//'D'//FLT(1:lentrim(FLT))//'.204',STATUS='unknown',recl=512,access='sequential')
      OPEN(26,FILE=OP(1:lentrim(OP))//'D'//FLT(1:lentrim(FLT))//'.205',STATUS='unknown',recl=512,access='sequential')
      OPEN(27,FILE=OP(1:lentrim(OP))//'D'//FLT(1:lentrim(FLT))//'.400',STATUS='unknown',recl=512,access='sequential')
      OPEN(36,FILE=OP(1:lentrim(OP))//'D'//FLT(1:lentrim(FLT))//'.STS',STATUS='unknown',recl=512,access='sequential')
      OPEN(92,FILE=OP(1:lentrim(OP))//'N'//FLT(1:lentrim(FLT))//'.C10',STATUS='unknown',recl=512,access='sequential')
      OPEN(14,FILE=OP(1:lentrim(OP))//'U'//FLT(1:lentrim(FLT))//'.C10',STATUS='unknown',recl=512,access='sequential')
c                        header information, 1 line
      WRITE(13,*) ' ID = BAD CR10 RECORD:  WRONG ID : ',INPUTDATA
      WRITE(20,*) ' ID = 100 ,  FLIGHT DATE : ',INPUTDATA
      WRITE(21,*) ' ID = 200 ,  FLIGHT DATE : ',INPUTDATA
      WRITE(22,*) ' ID = 201 ,  FLIGHT DATE : ',INPUTDATA
      WRITE(23,*) ' ID = 202 ,  FLIGHT DATE : ',INPUTDATA
      WRITE(24,*) ' ID = 203 ,  FLIGHT DATE : ',INPUTDATA
      WRITE(25,*) ' ID = 204 ,  FLIGHT DATE : ',INPUTDATA
      WRITE(26,*) ' ID = 205 ,  FLIGHT DATE : ',INPUTDATA
      WRITE(27,*) ' ID = 400 [normal exit],  FLIGHT DATE : ',INPUTDATA
      WRITE(36,*) ' ID = 205 STATUS : ',INPUTDATA
C counters for # records-- n1 is for total read
      n1=0 
	nbadid=0
	nbaddata=0
	utime0=-999.
	nneg=0
	idp=99
	lfirst=.true.
c --------------------------start of processing cycle---------------------
10	n1=n1+1
	read(12,'(a)',end=90,err=599)cr10line
c         note: internal read carried out on buffer 'cr10line'
	read(cr10line,*,err=1299)id
        if(id.eq.100 .or. id.eq.200 ) read(cr10line,*,err=1299)id,iyear,day,hhmm,secd
        if(id.eq.201)read(cr10line,*,err=1299)id,day,hhmm,secd
c compute time stamps, to be applied to following ID lines until hitting 201 or 100
	if(id.eq.201.or.id.eq.100 .or. id.eq.200 )then
      HOUR=HHMM/100.
      MINT=HHMM-HOUR*100
	endif
c          add 24 hours if the flight has crossed GMT 000 hr
	if(lfirst)then
                day1=day
        end if
      UTIME=HOUR*3600.+MINT*60.+SECD+(DAY-DAY1)*86400
	if(id.eq.201.or.id.eq.100)lfirst=.false.  
	if(utime.lt.utime0)then
		write(92,792) n1,utime,utime0,id,idp
		nneg=nneg+1
	endif
792	format('neg time diff, rec. #',i7,1x,f11.3,1x,f11.3,2i6)
	utime0=utime
C set first time to first '201'
check for bad ID (first record on the cr10line)
        if((id.ne.100).and.(id.lt.200.or.id.gt.205).and.(id.ne.400))go to 999
        if(id.eq.100) then
                n=20
        else
                n=21+id-200 
        end if
        if(id.eq.400)n=27
	nunit=n
c          ****************************
        READ(cr10line,*,END=89,ERR=1299) ID,(dip(i),i=1,nummit(n-19))
        write(nunit,20) UTIME,DAY,HOUR,MINT,SECD,(dip(i),i=1,nummit(n-19))
c          ****************************
c ==============this will be done in RPROGS
c       if(id.gt.200 .and. id .lt. 205)then
c               k=id-200
c               do j=1,16
c               if(k.eq.1)dip_cal(j)=dip(j+3)*calfacs(j,k)
c               if(k.ne.1)dip_cal(j)=dip(j)*calfacs(j,k)
c               end do
c               write(nunit+10,20) UTIME,DAY,HOUR,MINT,SECD,(dip_cal(i),i=1,16)
c       end if
        if(id.eq.205)then
                read(cr10line,*,END=89,ERR=1299) ID,x1,x2,(nstatus(i),i=1,3)
convert status words nstatus(i) to 12 integers either 1 or 0
                call status_c(nstatus(1),lstatus(1,1),12)
                call status_c(nstatus(2),lstatus(1,2),12)
                call status_c(nstatus(3),lstatus(1,3),12)
                write(36,271)UTIME,DAY,HOUR,MINT,SECD,((istatus(i,j),i=1,12),j=1,3)
        endif
	idp=id
        goto 10
20    FORMAT(F10.1,2x,i3,2X,I2,2X,I2,2X,F5.2, (20F10.2,1x))
271    format(F10.1,2x,i3,2X,I2,2X,I2,2X,F5.2,1x, (36(i1,1x)))
30    FORMAT(8(F9.2,1X))
140    FORMAT(I3,2X,F8.1,2X,I2,2X,I2,2X,F5.2,(/8(f9.2,1x)))
40    FORMAT(I3,2X,F8.1,2X,I2,2X,I2,2X,F5.2)
45    FORMAT(I3,2X,F8.1,2X,I2,2X,I2,2X,F5.2,2X,F2.0)
89      print *,'end of file, unit 12'
90      print *,'split_qcl normal exit, # records read =',n1
	print*,'bad rec ID=',nbadid,'; bad data fields=', nbaddata
	if(nneg.eq.0)print*,'There were',nneg,' neg. time intervals'
	if(nneg.ne.0)print*,'WARNING, there were',nneg,' neg. time intervals'
      CLOSE(12)
      CLOSE(13)
      CLOSE(36)
      do i=20,27
      close(i)
      enddo
        stop 0
999     write(13,'(a)')cr10line
	nbadid=nbadid+1
	go to 10
599     write(14,*)' unreadable record',n1
	print*,' unreadable record',n1
        nbaddata=nbaddata+1
        go to 10
1299    write(14,'(a)')cr10line
	write(14,*)' record #',n1
	nbaddata=nbaddata+1
        go to 10
        end

        subroutine status_c (istatus,kstatus,Nbits)
c       converts status word into integer status indicators
        integer istatus,twos(12)
        logical kstatus(12)
        data twos/2,4,8,16,32,64,128,256,512,1024,2048,4096/
        do i=1,Nbits
        kstatus(i)=mod(istatus,twos(i)).ge.(twos(i)/2)
        enddo
        return
        end 




