	PROGRAM SIGCONVh
c23456789012345678901234567890123456789012345678901234567890123
c **************LICOR OMS/Ballon data processing ************************
c         ******   [CO2] computation       ******
c **************LICOR OMS/Ballon data processing ************************
      CHARACTER*24 FILENAME
      CHARACTER*64 FIRSTLINE
	character*3 tanks(4),datatype(2)
      REAL UTIME,rtime,tv(6000),t2(6000),utsam(6000),
     x co2sam(6000),co2sam1(29000),utsam1(29000),
     x co2zer(6000),CO2G(6000),GAINS(600,3),gain1(3),
     x co2shi(6000),co2slo(6000),co2pri(6000),
     x utzer(6000),utshi(6000),utslo(6000),utpri(6000),
     x stds(4),ut(6000),ut201(29000),fbypass(29000),fsam(29000)
	REAL tshi(600),tslo(600),tzeros(600) ,tpri(600)
      REAL shi(600),slo(600),zeros(600),cals(3),pri(600)
	integer huntf,nz,nsam,npri,nl,nh
        logical btest
	data tanks/'hi-','zer','low','pri'/,datatype/'raw','con'/
	nordcal=4    
c order of cal inteprolation
	m=nordcal
c order of cal inteprolation
      OPEN(12,FILE='infile',STATUS='old',recl=512,access='sequential')
      read(12,'(A24)')filename
        close(12)
	print*,'looking for calfile S'//filename(2:7)//'.VAL'
	OPEN(12,FILE='S'//filename(2:7)//'.VAL',STATUS='old',recl=512,access='sequential')
c std conc's
	read(12,'(A24)')firstline
	read(12,*)stds,interval, nsdrop,NSTKEEP
c ! (1)=lo-span;(2)=ref;(3)=hi-span;(4)=primary; 
c interval=# 10-sec intervals stds "on"; # samples dropped after cal 
c    NSTKEEP, # std 10s intervals to use
	close(12)
      OPEN(31,FILE='O'//filename(2:7)//'.ZER',STATUS='old',recl=512,access='sequential') 
c  zero 10s median
      OPEN(32,FILE='O'//filename(2:7)//'.PRI',STATUS='old',recl=512,access='sequential') 
c  primary 10s median
      OPEN(33,FILE='O'//filename(2:7)//'.SLO',STATUS='old',recl=512,access='sequential') 
c  lo-cal 10s median
      OPEN(34,FILE='O'//filename(2:7)//'.SHI',STATUS='old',recl=512,access='sequential') 
c  hi-cal 10s median
      OPEN(35,FILE='O'//filename(2:7)//'.SAM',STATUS='old',recl=512,access='sequential') 
c  sample 10s median
      OPEN(37,FILE='O'//filename(2:7)//'.CON',STATUS='old',recl=512,access='sequential') 
c  complete 1s median
      OPEN(38,FILE='O'//filename(2:7)//'.201',STATUS='old',recl=512,access='sequential') 
c  1s housekeeping for flow data
	call readfile(31,nzer,co2zer,utzer)
	call readfile(32,npri,co2pri,utpri)
	call readfile(33,nslo,co2slo,utslo)
	call readfile(34,nshi,co2shi,utshi)
	call readfile(35,nsam,co2sam,utsam)
	if(nsam.gt.6000)then
	print*,'nsam=',nsam,' too large'
	stop 221
	endif
c readcon picks up 1s median, sample data only
	call readcon(37,nsam1,co2sam1,utsam1)
	if(nsam1.gt.29000)then
	print*,'nsam1=',nsam1,' too large'
	stop 227
	endif
c read201 housekeeping data, returns time (ut),bypass flow(sccm),sample fl.
	call read201(38,n201,fbypass,fsam,ut201)
	if(n201.gt.29000)then
	print*,'nsam=',nsam,' too large'
	stop 220
	endif
c **compute the medians, stripped of ndrop*10 secs, for interval*10s intervals
c ndrop = # 10-s intervals to drop *********
        ndrop=interval-NSTKEEP     
	interval2=2*interval
	ndrop2=interval2-6   
c  2x long cal for primary
c--  *** ZERO DATA POINTS ***
	call condense(co2zer,utzer,zeros,tzeros,interval,nzer,
     x     2,nz,ndrop)
c -- puts out nz 1-minute medians, in vector=zeros for time=tzeros
c-- skips 1st min of 1st zero (nstart=2); co2zer=mv CO2 in zero mode 
c-- (10s median)
c --utzer=times@10 s; nzer=#10s periods; nz=#1-min periods
7	format(7(f10.2,1x))
c-- *** CHANGED 3/5/95: nstart=2 ***  HI DATA POINTS:
	call condense(co2shi,utshi,shi,tshi,interval,nshi,
     x     2,nh,ndrop)
c -- skipping the first minute for all (nstart=2):  LO DATA POINTS
	call condense(co2slo,utslo,slo,tslo,interval,nslo,
     x     2,nl,ndrop)
	call condense(co2pri,utpri,pri,tpri,interval2,npri,
c    x     1,np,ndrop2) ! assumes 2x long primary cal
     x     1,np,ndrop )
c-START ****standards diagnostics****************************************
c record standard and primary data -- straight and condensed
	open(unit=98,file='S'//filename(2:7)//'.dat',status='unknown',recl=512)

	write(98,9887)tanks(1),datatype(1)
	write(98,9988)(i,utshi(i),co2shi(i),i=1,nshi)	
	write(98,9887)tanks(1),datatype(2)
	write(98,9988)(i,tshi(i),shi(i),i=1,nl)	

	write(98,9887)tanks(2),datatype(1)
	write(98,9988)(i,utzer(i),co2zer(i),i=1,nzer)	
	write(98,9887)tanks(2),datatype(2)
	write(98,9988)(i,tzeros(i),zeros(i),i=1,nl)	

	write(98,9887)tanks(3),datatype(1)
	write(98,9988)(i,utslo(i),co2slo(i),i=1,nslo)	
	write(98,9887)tanks(3),datatype(2)
	write(98,9988)(i,tslo(i),slo(i),i=1,nl)	

	write(98,9887)tanks(4),datatype(1)
	write(98,9988)(i,utpri(i),co2pri(i),i=1,npri)	
	write(98,9887)tanks(4),datatype(2)
	write(98,9988)(i,tpri(i),pri(i),i=1,nl)	

9988	format(i5,2x,2f8.2)
9887	format(a3,2x,  10Hdata type= , a3)
c -END****standards diagnostics******************************************
c-- ADD 60 seconds to begin at END of last calibration (i.e., at 1st sample)
	startt=max(utzer(1),utslo(1),utshi(1)) + 60. 
c  first calibrated time 
	startz=utzer(1)
	startc=startz 
c  begin from first zer
c!!!    startc=startt! begin from end of first cal sequence
     	endtc=max(tzeros(nz),tslo(nl),tshi(nh))
c last calibrated time
     	endt=tzeros(nz)                  
c last zero time
	write(14,*)startc,endt,nsam
c XXXXXXXXXXXXXXXXX START 10 SEC COMPUTATION XXXXXXXXXXXXXXXXXXXXXXXXXXXX
	OPEN(12,FILE='X'//filename(2:7)//'.CO2',status='unknown',recl=512,access='sequential') 
c  output file for 0.1 Hz data
      write(12,*)'UT secs | UT hrs  | [CO2] ppm | stds(mv)  hi,  ref, lo, CO2 (mv) int_ord kh kz kl' 
	nhunth=1
	nhuntl=1
	nco2=0
	nhuntz=1
	do 2999 i=nsdrop+1,nsam-1
        btest=utsam(i).lt.utsam(i-nsdrop)+10*nsdrop+1.
c    x   .and. utsam(i)+10.1.gt.utsam(i+1) 
c ignore nsdrop*10 sec after cals (nsdrop read in from Syymmdd.VAL)
c-- OBSOLETE drop last 10s interval before a time gap
	write(14,*)utsam(i),btest   
	if(utsam(i).ge.startc.and. btest)then
C	  if(utsam(i).ge.startc.and.utsam(i).le.endt       
C    x    .and. btest)then     
c calculate if sample time between designated start and end times
	  nco2=nco2+1
c nordcal default #pts used in the interpolation from Syymmdd.VAL
c <<<<<<<< select >>>>>>>> nord = order interp used == m
	nord=nordcal
	if((utsam(i).ge.endtc).or.(utsam(i).lt.startc+2000.))
     x          nord=3 
c if nhunt is 1 or 2, lower the order of the polynomial /__/
	if(min(nh,nz,nl).lt.3)nord=2
	m=nord
c if we have only two cals, use linear
c --- lower bound index--> nhunth; high cal interp to utsam(i)-->cals(3)
	  nhunth=huntf(tshi,nh,utsam(i),nhunth)				
	  kh=min(max(nhunth-(m-1)/2,1),nh+1-m) 
c Press p. 113 /2nd ed.	
	  call polint(tshi(kh),shi(kh),nord,utsam(i)
     x                ,cals(3),dcal3)	
	write(99,999)m,nh,nhunth,kh,tshi(kh),shi(kh)
     x   ,nord,cals(3),dcal3
999	format(4i5,2f10.2,i5,2f10.2)
c --------------  end interp for high cal/start ref::zero ----------------
	  nhuntz=huntf(tzeros,nz,utsam(i),nhuntz)			
	  kz=min(max(nhuntz-(m-1)/2,1),nz+1-m)				
	  call polint(tzeros(kz),zeros(kz),nord,utsam(i)
     x               ,cals(2),dcal2)	
c -------  end interp for zero/ref start lo cal -------------
	  nhuntl=huntf(tslo,nl,utsam(i),nhuntl)				
	  kl=min(max(nhuntl-(m-1)/2,1),nl+1-m)				
	  call polint(tslo(kl),slo(kl),nord
     x               ,utsam(i),cals(1),dcal3)        
	write(97,999)m,nl,nhuntl,kl,tslo(kl),slo(kl)
     x ,nord,cals(1),dcal3
c --<< end interp for low cal >>---<<<calc by interp CO2 with interp cals>>>
          call polint(cals,stds,3,co2sam(i),co2,dco2)     
	  ut(nco2)=utsam(i)                                	
          write(12,1553)ut(nco2),ut(nco2)/3600,co2,cals
     x      ,co2sam(i),nord,kh,kz,kl
	  end if
2999    CONTINUE
c **XXXXXXXXXXXXXXXXX END 10 SEC COMPUTATION do loop 2999 XXXXXXXXXXXXXXX
        close(12)
c XXXXXXXXXXXXXXXXX START 10 SEC PRIMARY  PPPPPPPPPPPPPPPPPPPPPPPPPPPP
	OPEN(32,FILE='X'//filename(2:7)//'.PRI',status='unknown',recl=512,access='sequential') 
c  output file for 0.1 Hz data
      write(32,*)'UT secs | UT hrs  | [CO2] ppm | stds(mv)  hi,  ref, lo, CO2 (mv), order_fit, kh, kz, kl'  
computed primary conc *all pts*'
	nhunth=1
	nhuntl=1
	nco2=0
	nhuntz=1
	do 2989 i=1,npri
c ignore nsdrop*10 sec after cals (nsdrop read in from Syymmdd.VAL)
c-- OBSOLETE drop last 10s interval before a time gap
	if(utpri(i).ge.startc)then
c calculate if sample time between designated start and end times
	  nco2=nco2+1
c nordcal default #pts used in the interpolation from Syymmdd.VAL
c <<<<<<<< select >>>>>>>> nord = order interp used == m
	nord=nordcal
	if((utpri(i).ge.endtc).or.(utpri(i).lt.startc+2000.))
     x          nord=3 
c if nhunt is 1 or 2, lower the order of the polynomial /__/
	if(min(nh,nz,nl).lt.3)nord=2
	m=nord
c if we have only two cals, use linear
c --- lower bound index--> nhunth; high cal interp to utpri(i)-->cals(3)
	  nhunth=huntf(tshi,nh,utpri(i),nhunth)				
	  kh=min(max(nhunth-(m-1)/2,1),nh+1-m) 
c Press p. 113 /2nd ed.	
	  call polint(tshi(kh),shi(kh),nord,utpri(i)
     x                ,cals(3),dcal3)	
	write(99,999)m,nh,nhunth,kh,tshi(kh),shi(kh)
     x   ,nord,cals(3),dcal3
c --------------  end interp for high cal/start ref::zero ----------------
	  nhuntz=huntf(tzeros,nz,utpri(i),nhuntz)			
	  kz=min(max(nhuntz-(m-1)/2,1),nz+1-m)				
	  call polint(tzeros(kz),zeros(kz),nord,utpri(i)
     x               ,cals(2),dcal2)	
c -------  end interp for zero/ref start lo cal -------------
	  nhuntl=huntf(tslo,nl,utpri(i),nhuntl)				
	  kl=min(max(nhuntl-(m-1)/2,1),nl+1-m)				
	  call polint(tslo(kl),slo(kl),nord
     x               ,utpri(i),cals(1),dcal3)        
	write(97,999)m,nl,nhuntl,kl,tslo(kl),slo(kl)
     x ,nord,cals(1),dcal3
c --<< end interp for low cal >>---<<<calc by interp CO2 with interp cals>>>
          call polint(cals,stds,3,co2pri(i),co2,dco2)     
	  ut(nco2)=utpri(i)                                	
          write(32,1553)ut(nco2),ut(nco2)/3600,co2,cals
     x      ,co2pri(i),nord,kh,kz,kl
	  end if
2989    CONTINUE
	close(32)
c **XXXXXXXXXXXXXXXXX END 10 SEC COMPUTATION PRIMARY 2989 PPPPPPPPPPPPPPPPPPPP
1553	format(f8.1,1x,f7.3,1x,f9.3,4f9.2,2x,i2,3i4)
c XXXXXXXXXXXXXXXXX START 2 SEC COMPUTATION XXXXXXXXXXXXXXXXXXXXXXXXXXXX
	OPEN(12,FILE='X'//filename(2:7)//'.HHZ',status='unknown',recl=512,access='sequential') 
c  output file for 0.5 Hz data
      write(12,*)'UT secs  | [CO2] ppm | UT sec corr'
	nhunth=1
	nhuntl=1
	nhuntz=1
	nco2=0
	i201=1
C	write(201,*)'n201=',n201-1,ut201(1),ut201(n201-1)
	do 2991 i=10*nsdrop+1,nsam1-1
        btest=utsam1(i).lt.utsam1(i-5*nsdrop)+10*nsdrop+1.
c ignore nsdrop*10 sec after cals (nsdrop read in from Syymmdd.VAL)
c-- OBSOLETE drop last 10s interval before a time gap
	  if(utsam1(i).ge.startc.and.btest)then     
C	  if(utsam1(i).ge.startc.and.utsam1(i).le.endt       
C    x    .and. btest)then     
c calculate if sample time between designated start and end times
	  nco2=nco2+1
c nordcal default #pts used in the interpolation from Syymmdd.VAL
c <<<<<<<< select >>>>>>>> nord = order interp used == m
	nord=nordcal
	if((utsam1(i).ge.endtc).or.(utsam1(i).lt.startc+2000.))
     x          nord=3 
c if nhunt is 1 or 2, lower the order of the polynomial /__/
	if(min(nh,nz,nl).lt.3)nord=2
	m=nord
c if we have only two cals, use linear
c --- lower bound index--> nhunth; high cal interp to utsam1(i)-->cals(3)
	  nhunth=huntf(tshi,nh,utsam1(i),nhunth)				
	  kh=min(max(nhunth-(m-1)/2,1),nh+1-m) 
c Press p. 113 /2nd ed.	
	  call polint(tshi(kh),shi(kh),nord,utsam1(i)
     x                ,cals(3),dcal3)	
c --------------  end interp for high cal/start ref::zero ----------------
	  nhuntz=huntf(tzeros,nz,utsam1(i),nhuntz)			
	  kz=min(max(nhuntz-(m-1)/2,1),nz+1-m)				
	  call polint(tzeros(kz),zeros(kz),nord,utsam1(i)
     x               ,cals(2),dcal2)	
c -------  end interp for zero/ref start lo cal -------------
	  nhuntl=huntf(tslo,nl,utsam1(i),nhuntl)				
	  kl=min(max(nhuntl-(m-1)/2,1),nl+1-m)				
	  call polint(tslo(kl),slo(kl),nord
     x               ,utsam1(i),cals(1),dcal3)        
c --<< end interp for low cal >>---<<<calc by interp CO2 with interp cals>>>
          call polint(cals,stds,3,co2sam1(i),co21,dco2)     
c -- compute delay time, cell vol=1.7*200sccm/60*760/330 (1.7 s delay @ 200sccm)
c -- bypass vol= 28*760/360 ;  find time for slows ASSUMING NO MISSING 201 LINES
CCC	i201=(utsam1(i)-ut201(1))/2.+1
	i201=huntf(ut201,n201-1,utsam1(i),i201)
	i201=min(max(i201-1/2,1),n201-1-1)
c	write(201,*),i201,i,ut201(i201),utsam1(i)
	if(abs(ut201(i201)-utsam1(i)).lt.2)then
	deltat=340./fsam(i201)
     x           +1680./(fsam(i201)+fbypass(i201)+40.)
	tcorr=utsam1(i)-deltat
c --   fbypass(i201)+40.==> zero value gives -40 reading 
	else
	tcorr=-999.
	end if
c insert -999 for tcorr if times son't match
          write(12,131)utsam1(i),co21,tcorr
	  end if
2991    CONTINUE
c **XXXXXXXXXXXXXXXXX END 1 SEC COMPUTATION do loop 2999 XXXXXXXXXXXXXXX
        close(12)
131	format(f8.1,1x,f9.3,1x,f8.1)
13	format(f8.1,1x,f7.3,1x,f9.3,4f9.2,3(1x,f7.2))
12	format(f8.1,1x,f9.3,1x,f9.3)
c use polint to obtain interpolated zeros and cals; then interpolate [CO2]
	print*,'normal exit from sigconvh'
       STOP 0
       end
c ++++++++++++++++ functions ++++++++++++++++++++++++++++++++++++
c ++++++++++++++++ functions ++++++++++++++++++++++++++++++++++++
c ++++++++++++++++ functions ++++++++++++++++++++++++++++++++++++
	function median(n,art)
c median of n points;  declare median==real.
code from p227 of Press, 1st ed.
	real arr(100),art(100),median,amedian,a
	integer n
	do 1999 k=1,n
	arr(k)=art(k)
1999	CONTINUE
 	do 12 j=2,n
	a=arr(j)
	do 11 i=j-1,1,-1
	if(arr(i).le.a) goto 10
 	arr(i+1)=arr(i)
11      continue
        i=0
10      arr(i+1)=a
12      continue
  	n2=n/2
        if (n2.eq.float(n)/2) amedian = (arr(n2)+arr(n2+1))/2.
        if (n2.ne.float(n)/2) amedian = arr(n2+1)
	median =amedian
2	return
	end
c ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	function huntf(xx,n,x,jlo1)
	INTEGER jlo,n,inc,jhi,jm,huntf,jlo1
	REAL x,xx(n)
c from numerical recipes, 1992 ed.  Given monotonic array xx(1:n) and a value x
c returns value=Jlo such that x is between xx(jlo) and xx(jlo+1).  0,n=exceed
c range. jlo1 on input is the initial guess;  used for searches with rolling
c best guess.  Index put into polint() polynomial interpolator.
	LOGICAL ascnd
	jlo=jlo1
        ascnd=xx(n).gt.xx(1)
        if(jlo.le.0.or.jlo.gt.n)then 
c go to bisection straight off
         jlo=0
	 jhi=n+1
	 goto 3
	end if
	inc=1
	if(x.ge.xx(jlo).eqv.ascnd)then 
c hunt up, increment inc
1           jhi=jlo+inc
            if(jhi.gt.n)then
               jhi=n+1
            else if(x.ge.xx(jhi).eqv.ascnd)then 
c not done hunting
               jlo=jhi
               inc=inc+inc 
c double increment
               goto 1
            end if
         else                           
c hunt down
            jhi=jlo
2           jlo=jhi-inc
            if(jlo.lt.1)then
               jlo=0
            else if(x.lt.xx(jlo).eqv.ascnd)then
               jhi=jlo
               inc=inc+inc
               goto 2
            end if
        end if                          
c end of hunt for bracketting indexes
3 	if(jhi-jlo.eq.1)goto 30
        jm=(jhi+jlo)/2         
c begin biscection
        if(x.gt.xx(jm).eqv.ascnd)then
          jlo=jm
        else
          jhi=jm
        end if
        goto 3
30      huntf=jlo
        return
	END
c ++++++++++++++++ subroutines ++++++++++++++++++++++++++++++++++++++++
c ++++++++++++++++ subroutines ++++++++++++++++++++++++++++++++++++++++
	subroutine condense(co2x,utx,x,tmean,interval,nco2x,
     x     nstart,nx,ndrop)
c condense via median filter, 10-sec medians-->medians in interval
c (or smaller in case there are fewer data).  Used to get interpolation
c data
      real co2x(nco2x),utx(nco2x),x(1),tmean(1),median
	integer nx,nco2x,interval,ndrop,nstart
	ndr=min(ndrop,interval-1) 
c  at least one interval taken
	nx=nco2x/interval 
	print*,ndr,nx,nstart,ndrop,nco2x
c number of complete calibrations
	nmedian=interval-ndr
        do 1001 i=nstart,nx
	j=(i-1)*interval+ndr+1 
c index of first value to be median/d
	x(i)=median(nmedian,co2x(j)) 
c  median fcn must not re-order
	tmean(i)=median(nmedian,utx(j)) 
1001    continue	
	return
	end
c ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	SUBROUTINE POLINT(xa,ya,n,x,y,dy)
c Given arrays xa,ya, each length n, and value x, returns value y and
c error est dy.  P(x) is polynomial deg N-1, such that P(xai)=yai, i=i,n
c then the reruned value y = P(x).
	INTEGER n,NMAX,i,m,ns
	parameter (NMAX=10)
	REAL dy,x,y,xa(n),ya(n),den,dif,dift,ho,hp,w,c(NMAX)
     x   ,d(NMAX)
c if we are interpolating in arrays XX and YY, call will be
c polint(XX(k),YY(k),m,x,y,dy), where J is select from hunt (finds lower-bound
c index jlb) and k=min(max(jlb-(m-1)/2,1),n+1-m) //m=order of interpolation
        ns=1
	dif=abs(x-xa(1))
	do 1998 i=1,n
	dift=abs(x-xa(i))
	if(dift.lt.dif)then
		ns=i
		dif=dift
	end if
		c(i)=ya(i)
		d(i)=ya(i)
1998	CONTINUE
	y=ya(ns)
	ns=ns-1
	do 1997  m=1,n-1
		do 1996 i=1,n-m
		  ho=xa(i)-x
		  hp=xa(i+m)-x
		  w=c(i+1)-d(i)
		  den=ho-hp
		  if(den.eq.0) then
		    print*,'failure in polint / dup points'
			y=-999
			return
			end if
		  den=w/den
		  d(i)=hp*den
		  c(i)=ho*den
1996	        CONTINUE
		if(2*ns.lt.n-m)then
			dy=c(ns+1)
		else
			dy=d(ns)
			ns=ns-1
		end if
		y=y+dy
1997	CONTINUE
	return
	end	
c ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
        subroutine readfile(nu,nread,arr,trr)
c reads data from files created by sigsplt
        real arr(6000),trr(6000)
        integer nread,nu
        nread=1
1       read(nu,*,end=2,err=21)trr(nread),arr(nread)
        nread=nread+1
        goto 1
2       print*,nread,'Number of lines read on ',nu
        close(nu)
        return
21      print*,'Error reading ',nu
        stop 9
        end
        subroutine readcon(nu,nread,arr,trr)
c reads data from file Oyymmdd.CON, only sample data created by sigsplt
c averages to get 1/2 hz
        real arr(33000),trr(33000)
        integer nread,nu
        nread=1
1       read(nu,*,end=2,err=21)trx,arx,isolflg
	if(isolflg.ne.16)goto1
        read(nu,*,end=2,err=21)trx1,arx1,isolflg1
	if(isolflg1.ne.16)goto1
        nread=nread+1
	trr(nread)=trx
c uses the earlier time
	arr(nread)=(arx+arx1)/2.
        goto 1
2       print*,nread*2,'Number of lines read on ',nu
        close(nu)
        return
21      print*,'Error reading ',nu
        stop 9
        end
        subroutine read201(nu,nread,arr,brr,trr)
c reads data from file Oyymmdd.201
C returns time in ut, bypass(arr) and sample(brr) flows in sccm
        real arr(29000),brr(29000),trr(29000),F201DATA(13)
	character*64 firstline
        integer nread,nu,hour,mint
        nread=1
	read(nu,'(A64)')firstline
20      FORMAT(F8.2,2X,I2,2X,I2,2X,F5.2)
40      FORMAT(8(F9.2,1X))
1	read(nu,20,end=2,err=21)UTIME,HOUR,MINT,SECD       
	read(nu,40,end=2,err=21)F201DATA
	read(nu,20,end=2,err=21)UTIME,HOUR,MINT,SECD       
	read(nu,40,end=2,err=21)F201DATA
c gives 1/2Hz readout
	trr(nread)=UTIME
c	arr(nread)=F201DATA(7)
c	brr(nread)=F201DATA(8)
 	arr(nread)=F201DATA(5)
 	brr(nread)=F201DATA(6)
        nread=nread+1
        goto 1
2       print*,nread*2 ,'Number of lines read on ',nu
        close(nu)
        return
21      print*,'Error reading ',nu
        stop 9
        end
c ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE POLCOF(XA,YA,N,COF)
c------------------------------------------------ from Press first ed.
      PARAMETER (NMAX=15)
      DIMENSION XA(N),YA(N),COF(N),X(NMAX),Y(NMAX)
      DO 11 J=1,N
        X(J)=XA(J)
        Y(J)=YA(J)
11    CONTINUE
      DO 14 J=1,N
        CALL POLINT(X,Y,N+1-J,0.,COF(J),DY)
        XMIN=1.E38
        K=0
        DO 12 I=1,N+1-J
          IF (ABS(X(I)).LT.XMIN)THEN
            XMIN=ABS(X(I))
            K=I
          end if
          IF(X(I).NE.0.)Y(I)=(Y(I)-COF(J))/X(I)
12      CONTINUE
        IF (K.LT.N+1-J) THEN
          DO 13 I=K+1,N+1-J
            Y(I-1)=Y(I)
            X(I-1)=X(I)
13        CONTINUE
        end if
14    CONTINUE
      RETURN
      END
c ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE POLCOE(X,Y,N,COF)
      PARAMETER (NMAX=15)
      DIMENSION X(N),Y(N),COF(N),S(NMAX)
      DO 11 I=1,N
        S(I)=0.
        COF(I)=0.
11    CONTINUE
      S(N)=-X(1)
      DO 13 I=2,N
        DO 12 J=N+1-I,N-1
          S(J)=S(J)-X(I)*S(J+1)
12      CONTINUE
        S(N)=S(N)-X(I)
13    CONTINUE
      DO 16 J=1,N
        PHI=N
        DO 14 K=N-1,1,-1
          PHI=K*S(K+1)+X(J)*PHI
14      CONTINUE
        FF=Y(J)/PHI
        B=1.
        DO 15 K=N,1,-1
          COF(K)=COF(K)+B*FF
          B=S(K)+X(J)*B
15      CONTINUE
16    CONTINUE
      RETURN
      END


