c23456789012345678901234567890123456789012345678901234567890123
        program split_qcl
	implicit real*8 (a-h,o-z)
      CHARACTER INPUTDATA*50,cr10line*512,format_files(4)*50
      real*8 dip(58),calfacs(16,4),dip_cal(16), UTIME
      INTEGER id,HOUR,MINT,nummit(7),day,day1,nstatus(3),istatus(12,3)
	logical lfirst,lstatus(12,3)
        equivalence (istatus,lstatus)
      data nummit/4,4,19,16,16,16,12/
C nummit is (number of data points per line -1 <ID is NOT Counted>)
C  1==100;2==200;3==201; 4==202 5==203  6==204  7==205
c 'infile' contains 5 rows: 1. name of data file; 2-5 format files for ID=201-204
C Naming for QCLs: H20080416_1.DAT but any name is OK, characters (2:11) to tag other filenames.
	open(55,file='infile',status='old')
c
      READ(55,'(A24)') INPUTDATA
      print*,'Input data file is: ',inputdata
      READ(55,'(A50)') (format_files(i),i=1,4)
      print*,(format_files(i)(1:len_trim(format_files(i))),i=1,4)
      do i=1,4
      open(10,file=format_files(i)(1:len_trim(format_files(i))),status='OLD')
      print*,'Reading calfacs file= ',format_files(i)
c     read(10,109)(calfacs(j,i),j=1,15)
      print*,(calfacs(j,i),j=1,15),' ',i
      read(10,109)(calfacs(j,i),j=1,16)
109     format(f6.0)
c     print*,i,(calfacs(j,i),j=1,16)
      close(10)
      end do
      OPEN(12,FILE=INPUTDATA,STATUS='OLD',recl=512,access='sequential')
      OPEN(13,FILE='D'//INPUTDATA(2:11)//'.ERR',STATUS='unknown',recl=512,access='sequential')
      OPEN(20,FILE='D'//INPUTDATA(2:11)//'.100',STATUS='unknown',recl=512,access='sequential')
      OPEN(21,FILE='D'//INPUTDATA(2:11)//'.200',STATUS='unknown',recl=512,access='sequential')
      OPEN(22,FILE='D'//INPUTDATA(2:11)//'.201',STATUS='unknown',recl=512,access='sequential')
      OPEN(23,FILE='D'//INPUTDATA(2:11)//'.202',STATUS='unknown',recl=512,access='sequential')
      OPEN(24,FILE='D'//INPUTDATA(2:11)//'.203',STATUS='unknown',recl=512,access='sequential')
      OPEN(25,FILE='D'//INPUTDATA(2:11)//'.204',STATUS='unknown',recl=512,access='sequential')
      OPEN(26,FILE='D'//INPUTDATA(2:11)//'.205',STATUS='unknown',recl=512,access='sequential')
      OPEN(27,FILE='D'//INPUTDATA(2:11)//'.STS',STATUS='unknown',recl=512,access='sequential')
      OPEN(32,FILE='O'//INPUTDATA(2:11)//'.201',STATUS='unknown',recl=512,access='sequential')
      OPEN(33,FILE='O'//INPUTDATA(2:11)//'.202',STATUS='unknown',recl=512,access='sequential')
      OPEN(34,FILE='O'//INPUTDATA(2:11)//'.203',STATUS='unknown',recl=512,access='sequential')
      OPEN(35,FILE='O'//INPUTDATA(2:11)//'.204',STATUS='unknown',recl=512,access='sequential')
c                        header information, 1 line
      WRITE(13,*) ' ID = BAD CR10 RECORD:  WRONG ID : ',INPUTDATA
      WRITE(20,*) ' ID = 100 ,  FLIGHT DATE : ',INPUTDATA
      WRITE(21,*) ' ID = 200 ,  FLIGHT DATE : ',INPUTDATA
      WRITE(22,*) ' ID = 201 ,  FLIGHT DATE : ',INPUTDATA
      WRITE(23,*) ' ID = 202 ,  FLIGHT DATE : ',INPUTDATA
      WRITE(24,*) ' ID = 203 ,  FLIGHT DATE : ',INPUTDATA
      WRITE(25,*) ' ID = 204 ,  FLIGHT DATE : ',INPUTDATA
      WRITE(26,*) ' ID = 205 ,  FLIGHT DATE : ',INPUTDATA
      WRITE(27,*) ' ID = 205 STATUS : ',INPUTDATA
C counters for # records-- n1 is for total read
      n1=0 
	nbadid=0
	nbaddata=0
	utime0=-999.
	nneg=0
	idp=99
	lfirst=.true.
c --------------------------start of processing cycle---------------------
10	n1=n1+1
	read(12,'(a)',end=90,err=599)cr10line
c         note: internal read carried out on buffer 'cr10line'
	read(cr10line,*,err=1299)id
        if(id.eq.100 .or. id.eq.200 ) read(cr10line,*,err=1299)id,iyear,day,hhmm,secd
        if(id.eq.201)read(cr10line,*,err=1299)id,day,hhmm,secd
c compute time stamps, to be applied to following ID lines until hitting 201 or 100
	if(id.eq.201.or.id.eq.100 .or. id.eq.200 )then
      HOUR=HHMM/100.
      MINT=HHMM-HOUR*100
	endif
c          add 24 hours if the flight has crossed GMT 000 hr
	if(lfirst)then
                day1=day
        end if
      UTIME=HOUR*3600.+MINT*60.+SECD+(DAY-DAY1)*86400
	if(id.eq.201.or.id.eq.100)lfirst=.false.  
	if(utime.lt.utime0)then
		write(92,792) n1,utime,utime0,id,idp
		nneg=nneg+1
	endif
792	format('neg time diff, rec. #',i7,1x,f11.3,1x,f11.3,2i6)
	utime0=utime
C set first time to first '201'
check for bad ID (first record on the cr10line)
        if((id.ne.100).and.(id.lt.200.or.id.gt.205))go to 999
        if(id.eq.100) then
                n=20
        else
                n=21+id-200 
        end if
	nunit=n
c          ****************************
        READ(cr10line,*,END=89,ERR=1299) ID,(dip(i),i=1,nummit(n-19))
        write(nunit,20) UTIME,HOUR,MINT,SECD,(dip(i),i=1,nummit(n-19))
c          ****************************
        if(id.gt.200 .and. id .lt. 205)then
                k=id-200
                do j=1,16
                if(k.eq.1)dip_cal(j)=dip(j+3)*calfacs(j,k)
                if(k.ne.1)dip_cal(j)=dip(j)*calfacs(j,k)
                end do
                write(nunit+10,20) UTIME,HOUR,MINT,SECD,(dip_cal(i),i=1,16)
        end if
        if(id.eq.205)then
                read(cr10line,*,END=89,ERR=1299) ID,x1,x2,(nstatus(i),i=1,3)
convert status words nstatus(i) to 12 integers either 1 or 0
                call status_c(nstatus(1),lstatus(1,1),12)
                call status_c(nstatus(2),lstatus(1,2),12)
                call status_c(nstatus(3),lstatus(1,3),12)
                write(27,271)UTIME,HOUR,MINT,SECD,((istatus(i,j),i=1,12),j=1,3)
        endif
	idp=id
        goto 10
20    FORMAT(F8.1,2X,I2,2X,I2,2X,F5.2, (20F10.2,1x))
271    format(F8.1,2X,I2,2X,I2,2X,F5.2,1x, (36(i1,1x)))
30    FORMAT(8(F9.2,1X))
140    FORMAT(I3,2X,F8.1,2X,I2,2X,I2,2X,F5.2,(/8(f9.2,1x)))
40    FORMAT(I3,2X,F8.1,2X,I2,2X,I2,2X,F5.2)
45    FORMAT(I3,2X,F8.1,2X,I2,2X,I2,2X,F5.2,2X,F2.0)
89      print *,'end of file, unit 12'
90      print *,'split_qcl normal exit, # records read =',n1
	print*,'bad rec ID=',nbadid,'; bad data fields=', nbaddata
	if(nneg.eq.0)print*,'There were',nneg,' neg. time intervals'
	if(nneg.ne.0)print*,'WARNING, there were',nneg,' neg. time intervals'
      CLOSE(12)
      CLOSE(13)
      do i=20,27
      close(i)
      if(i.gt.21 .and. i.lt.26)close(i+10)
      enddo
        stop 0
999     write(13,'(a)')cr10line
	nbadid=nbadid+1
	go to 10
599     write(14,*)' unreadable record',n1
	print*,' unreadable record',n1
        nbaddata=nbaddata+1
        go to 10
1299    write(14,'(a)')cr10line
	write(14,*)' record #',n1
	nbaddata=nbaddata+1
        go to 10
        end

        subroutine status_c (istatus,kstatus,Nbits)
c       converts status word into integer status indicators
        integer istatus,twos(12)
        logical kstatus(12)
        data twos/2,4,8,16,32,64,128,256,512,1024,2048,4096/
        do i=1,Nbits
        kstatus(i)=mod(istatus,twos(i)).ge.(twos(i)/2)
        enddo
        return
        end 



